//Utility functions
Ext.namespace("SYNO.SDS.TeamViewer.Utils");
Ext.apply(SYNO.SDS.TeamViewer.Utils, {
	GetHtmlData: function() {

		var boxStyleWithoutWidth = "font-size:12px;font-weight:200;background-color:#038ff4;vertical-align:middle;height:11px;padding:7px;color:#ffffff;float:left;border-radius:3px 0px 0px 3px"
		var rightArrowStyle = "width:0;height:0;float:left;border-top: 13px solid transparent;border-bottom: 12px solid transparent;border-left: 13px solid #038ff4";

		var html = '';

		// Start Header
		html += '<div id="main" style="padding-left: 20px; padding-right: 20px; padding-top: 10px; padding-bottom: 10px;font-family:Arial;line-height:1">';
		html += '<p style="font-size:24px;font-weight:300;color:#43474d;margin-bottom:13px;height:32px">Device Information</p>';
		// End Header

		// Start div TV_ID
		html += '<div style="' + boxStyleWithoutWidth + 'width:70px;">YOUR ID</div>';
		html += '<div style="' + rightArrowStyle + '"></div>';
		html += '<div id="TV_ID" class="selectabletext" style="font-size:24px;font-weight:200;vertical-align:bottom;margin-top:5px;margin-bottom:0px;height:20px;float:right;color:#43474d"> - </div>';
		// End TV_ID

		html += '<p style="clear:both"></p>';
		html += '<hr width="100%" color="Lavender" style="margin-top:5px;margin-bottom:5px" noshade>';

		// Start div password_area
		html += '<div id="password_area" style="display:block">';
			html += '<div style="' + boxStyleWithoutWidth + 'width:70px;">PASSWORD</div>';
			html += '<div style="' + rightArrowStyle + '"></div>';
			html += '<div id="TV_Pass" class="selectabletext" style="font-size:24px;font-weight:200;height:24px;margin-top:-2px;float:right;color:#43474d; padding-bottom:21px"> - </div>';
		html += '</div>';
		// End div password_area

		// Start div manager_area
		html += '<div id="manager_area" style="display:none">';
			html += '<div style="' + boxStyleWithoutWidth + 'width:90px;">ASSIGNED TO</div>';
			html += '<div style="' + rightArrowStyle + '"></div>';

			html += '<div style="float:right;vertical-align:top">';
				html += '<span id="TV_Manager" style="display:inline-block;font-size:24px;font-weight:200;height:24px;width:220px;color:#43474d;margin-top:-2px;padding-bottom:7px;overflow:hidden;white-space:nowrap;text-overflow:ellipsis;text-align:right;"></span></br>';
				html += '<span id="TV_UnregisterManagerContainer" style="display:none;float:right">';
					html += '<button id="TV_UnregisterManager" class="x-btn-text" style="background-color:#ffffff;border:none;color:#038ff4;font-size:14px;font-weight:200;text-decoration:underline;margin-top:-5px;height:17px" type="button">Remove Assignment</button>';
				html += '</span>';
			html += '</div>';
		html += '</div>';
		// End div manager_area

		html += '<p style="clear:both"></p>';
		html += '<p id="ConnMsg" style="font-size:14px;font-weight:400; color:#ff0000; display:none;margin-top:-5px;height:14px">';
		html += 'TeamViewer service is offline';
		html += '</p>';

		//Start div TV_RemoteTerminal
		html += '<p style="clear:both"></p>';
		html += '<div id="TV_RemoteTerminal" style="display:block; margin-top:20px;opacity:0.4">';

		html += '<div style="' + boxStyleWithoutWidth + 'width:120px;">REMOTE TERMINAL</div>';
		html += '<div style="' + rightArrowStyle + '"></div>';

		html += '<div style="height:24px; float:right; width:50px; border-radius:15px 15px 15px 15px;position:relative">';

		html += '<div id="TV_TerminalButtonDisabled" style="display:block;font-size:11px; font-weight:200; background-color:#f0f0f0; height:24px; float:right; width:50px;vertical-align:middle; color:#ffffff;  border-radius:15px 15px 15px 15px; border: 1px solid #038ff4; position:relative">';
		html += '<div style="height:16px; width:16px; float:left; background-color:#ffffff; border-radius: 50%; margin-top:3px; margin-left:5px; border: 1px #038ff4 solid; position:absolute"></div>';
		html += '<div style="height:24px; line-height:24px; width:20px; float:right; background-color:transparent; border:none; margin-right:5px; color:#038ff4;text-align:center;">OFF</div>';
		html += '</div>';

		html += '<div id="TV_TerminalButtonEnabled" style="display:none;font-size:11px; font-weight:200; background-color:#038ff4; height:24px; float:right; width:50px;vertical-align:middle; color:#ffffff;  border-radius:15px 15px 15px 15px; border: 1px solid #038ff4; position:relative">';

		html += '<div style="height:24px; line-height:24px; width:20px; float:left; background-color:transparent; border:none; margin-left:5px; color:#ffffff;text-align:center;">ON</div>';
		html += '<div style="height:16px; width:16px; float:right; background-color:#ffffff; border-radius: 50%; margin-top:3px; margin-right:5px; border:1px Lavender solid" ></div>';
		html += '</div>';

		html += '<button id="TV_TerminalButton" style="background-color:transparent; border:none; height:100%; width:100%;vertical-align:middle;position:absolute; top:0; border-radius:15px 15px 15px 15px;" disabled></button>';

		html += '</div>';
		html += '</div>';
		// End div TV_RemoteTerminal

		html += '<p style="clear:both"></p>';
		html += '<p style="font-size:24px;font-weight:300;color:#3474d ;height:33px;margin-top:20px;margin-bottom:13px">Instruction</p>'

		html += '<p id="TV_Description1" style="font-size:14px;color:#1f262d;font-weight:400;margin-bottom:15px;height:34px">If your Synology Box is in your local area network, you can add it to your contact list under \"Nearby contacts and devices\".';
		html += '</p>';
		html += '<p id="TV_Description2" style="font-size:14px;color:#1f262d;font-weight:400;margin-bottom:20px;height:34px">If you are not in your local area network, you can add it with the above ID and Password. Then assign this device to your account using Remote Assignment. <a style="color:#038ff4;text-decoration:underline" target="_blank" href="http://www.teamviewer.com/link/?url=904843">More information</a>';
		html += '</p>';

		html += '<button class="x-btn-text" style="background-color:#ffffff;border:none;color:#038ff4;font-size:14px;border-radius:0px;margin-bottom:13px;margin-top:13px;font-weight:200;text-decoration:underline;height:17px" type="button" id="TVDownloadSupport">Download Support Information</button>';
		html += '<hr width="100%" color="Lavender" style="margin-bottom:10px" noshade>';
		html += '<a class="link-font" style="float:left;font-size:13px;font-weight:400;color:#038ff4;height:14px;text-decoration:underline;padding-bottom:2px" href="#" id="TVThirdPartyLicense">Third Party Licenses</a>';
		html += '<a class="link-font" style="float:right;font-size:13px;font-weight:normal;color:#038ff4;height:14px;text-decoration:underline" target="_blank" href="https://www.TeamViewer.com">www.teamviewer.com</a>';
		html += '</div>';

		return html;
	},
	DefaultState: function() {

		document.getElementById("TV_ID").innerHTML = " -  ";
		document.getElementById("TV_Pass").innerHTML = " - ";
		document.getElementById("password_area").style.display = "block";
		document.getElementById("manager_area").style.display = "none";
		document.getElementById("ConnMsg").style.display = "block";
		document.getElementById("TV_UnregisterManagerContainer").style.visibility = "hidden";
		document.getElementById("TV_RemoteTerminal").style.opacity = "0.4";
		document.getElementById("TV_TerminalButton").disabled = true;
	},
	GetDeviceInfo: function(ApplicationWindow) {

		Ext.Ajax.request({
			url: SYNO.SDS.TeamViewer.TeamViewerURL + "/TeamViewerWebSupport.cgi",
			scope: this,
			method: "GET",
			params: "method=GetDeviceInfo",
			success: function(response) {
				if(typeof response !== "undefined")
				{
					if (SYNO.SDS.TeamViewer.UpdateUI === true)
					{
						if(response.responseText)
						{
							SYNO.SDS.TeamViewer.DeviceInfo = Ext.util.JSON.decode(response.responseText, true);

							if(SYNO.SDS.TeamViewer.DeviceInfo != null)
							{
								if((typeof SYNO.SDS.TeamViewer.DeviceInfo.DaemonStatus != 'undefined') && (SYNO.SDS.TeamViewer.DeviceInfo.DaemonStatus.localeCompare("Restart") == 0))
								{
									document.getElementById("ConnMsg").innerHTML = "Restarting TeamViewer service, please wait...";
									SYNO.SDS.TeamViewer.Utils.DefaultState();
								}
								else if((typeof SYNO.SDS.TeamViewer.DeviceInfo.TeamViewerID != 'undefined') && (SYNO.SDS.TeamViewer.DeviceInfo.Status.localeCompare("Online") == 0))
								{
									document.getElementById("TV_ID").innerHTML = SYNO.SDS.TeamViewer.DeviceInfo.TeamViewerID.toString().replace(/\B(?=(\d{3})+(?!\d))/g, " ");

									if((typeof SYNO.SDS.TeamViewer.DeviceInfo.ManagerName != 'undefined') &&
									   (SYNO.SDS.TeamViewer.DeviceInfo.ManagerName !== SYNO.SDS.TeamViewer.DeviceManager))
									{
										SYNO.SDS.TeamViewer.DeviceManager = SYNO.SDS.TeamViewer.DeviceInfo.ManagerName;
									}

									if(SYNO.SDS.TeamViewer.DeviceManager === "")
									{
										document.getElementById("password_area").style.display = "block";
										document.getElementById("manager_area").style.display = "none";
										document.getElementById("TV_Pass").innerHTML = SYNO.SDS.TeamViewer.SynologySerial;
										document.getElementById("TV_Manager").innerHTML = "No manager assigned";
										document.getElementById("TV_UnregisterManagerContainer").style.display = "none";
										document.getElementById("TV_RemoteTerminal").style.opacity = "0.4";
										document.getElementById("TV_TerminalButton").disabled = true;
										document.getElementById("TV_Description1").innerHTML = "If your Synology Box is in your local area network, you can add it to your contact list under \"Nearby contacts and devices\".";
										document.getElementById("TV_Description2").innerHTML = 'If you are not in your local area network, you can add it with the above ID and Password. Then assign this device to your account using Remote Assignment. <a style="color:#038ff4;text-decoration:underline" target="_blank" href="http://www.teamviewer.com/link/?url=904843">More information</a>';
									}
									else
									{
										document.getElementById("password_area").style.display = "none";
										document.getElementById("manager_area").style.display = "block";
										document.getElementById("TV_Pass").innerHTML = " -  ";
										document.getElementById("TV_Manager").innerHTML = SYNO.SDS.TeamViewer.DeviceManager;
										document.getElementById("TV_RemoteTerminal").style.opacity = "1";
										document.getElementById("TV_Description1").innerHTML = "This device has an assigned manager and only the manager has rights to access or share this device with other users.";
										document.getElementById("TV_Description2").innerHTML = "If you have admin rights on this device, you can make this device unassigned by clicking \"Remove Assignment\". Then you can add the device again by using the above ID and generated Password.";
										if (true === _S("is_admin"))
										{
											document.getElementById("TV_UnregisterManagerContainer").style.visibility = "visible";
											document.getElementById("TV_UnregisterManagerContainer").style.display = "inline-block";
											document.getElementById("TV_UnregisterManagerContainer").className = "";
											document.getElementById("TV_UnregisterManager").disabled = false;
											document.getElementById("TV_TerminalButton").disabled = false;
										}
									}
									document.getElementById("ConnMsg").style.display = "none";
								}
								else
								{
									document.getElementById("ConnMsg").innerHTML = "TeamViewer service is offline"
									SYNO.SDS.TeamViewer.Utils.DefaultState();
								}

								var terminalStatus = (Number(SYNO.SDS.TeamViewer.DeviceInfo.RemoteTerminalStatus) != 0);
								if (terminalStatus != SYNO.SDS.TeamViewer.IsTerminalEnabled)
								{
									if (terminalStatus)
									{
										SYNO.SDS.TeamViewer.Utils.EnableRemoteTerminal(ApplicationWindow);
									}
									else
									{
										SYNO.SDS.TeamViewer.Utils.DisableRemoteTerminal(ApplicationWindow);
									}
								}
							}
							else
							{
								document.getElementById("ConnMsg").innerHTML = "Unable to obtain TeamViewer information, please restart TeamViewer"
								SYNO.SDS.TeamViewer.Utils.DefaultState();
							}
						}
						else
						{
							document.getElementById("ConnMsg").innerHTML = "Unable to obtain TeamViewer information, please restart TeamViewer"
							SYNO.SDS.TeamViewer.Utils.DefaultState();
							SYNO.SDS.TeamViewer.Utils.DisableRemoteTerminal(ApplicationWindow);
							document.getElementById("TV_RemoteTerminal").style.opacity = "0.4";
							document.getElementById("TV_TerminalButton").disabled = true;
						}
					}
				}
				SYNO.SDS.TeamViewer.TimeOutID = setTimeout(function() {
					SYNO.SDS.TeamViewer.Utils.GetDeviceInfo(ApplicationWindow);
				}, 5000);
				return;
			},
			failure: function(response, connection) {
				if(typeof response !== "undefined")
				{
					if (response.status == "403" || response.status == "401")
					{
						ApplicationWindow.getMsgBox().alert(_T("error", "error_error"), "Error in getting Device Info. \nStatus: " + response.status + "\nReason: " + response.statusText);
					}
					else
					{
						//Don't show the alert box for this error message. User should not be aware of these kinds of events.
						console.log("Error in getting Device Info. \nStatus: " + response.status + "\nReason: " + response.statusText);


							SYNO.SDS.TeamViewer.TimeOutID = setTimeout(function() {
								SYNO.SDS.TeamViewer.Utils.GetDeviceInfo(ApplicationWindow);
							}, 5000);
					}
				}
				return;
			}
		});
	},
	DownloadSupportFile: function(ApplicationWindow) {

		Ext.Ajax.request({
			url: SYNO.SDS.TeamViewer.TeamViewerURL + "/TeamViewerWebSupport.cgi",
			scope: this,
			method: "GET",
			params: "method=DownloadSupportFile",
			success: function(response) {

				try {
					Ext.destroy(Ext.get('tv-downloadIframe'));
				}
				catch(e) {}
				Ext.DomHelper.append(document.body, {
					tag: 'iframe',
					id:'tv-downloadIframe',
					frameBorder: 0,
					width: 0,
					height: 0,
					css: 'display:none;visibility:hidden;height:0px;',
					src: SYNO.SDS.TeamViewer.TeamViewerURL +  "/" + response.responseText
				});
				return;
			},
			failure: function(response, connection) {
				ApplicationWindow.getMsgBox().alert(_T("error", "error_error"), "Error in downloading support file. \nReason: " + response.statusText);
				return;
			}
		});
	},
	ThirdPartyLicense: function(ApplicationWindow) {

		try {
			Ext.destroy(Ext.get('tv-licenseIframe'));
		}
		catch(e) {}
		Ext.DomHelper.append(document.body, {
			tag: 'iframe',
			id:'tv-licenseIframe',
			frameBorder: 0,
			width: 0,
			height: 0,
			css: 'display:none;visibility:hidden;height:0px;',
			src: SYNO.SDS.TeamViewer.TeamViewerURL + "/TeamViewerWebSupport.cgi?_dc=" + (new Date().getTime()) + "&SynoToken=" + SYNO.SDS.Session.SynoToken + "&method=ThirdPartyLicense"
		});
	},
	UnregisterDeviceManager: function(ApplicationWindow) {
		if (true === _S("is_admin"))
		{
			ApplicationWindow.getMsgBox().confirm('TeamViewer','Do you want this device to be unassigned?</br> \
													<span style="font-size:0.9em">Note: If you are logged in via TeamViewer then your TeamViewer session will be closed and \
													you won\'t be able to connect to your Synology until you assign it to your account again.</span>',function(btn){
				if("yes" === btn)
				{
					clearTimeout(SYNO.SDS.TeamViewer.TimeOutID);
					SYNO.SDS.TeamViewer.UpdateUI = false;

					document.getElementById("TV_UnregisterManagerContainer").className = "x-item-disabled";
					document.getElementById("TV_UnregisterManager").disabled = true;

					document.getElementById("TV_RemoteTerminal").style.opacity = "0.4";
					document.getElementById("TV_TerminalButton").disabled = true;

					document.getElementById("ConnMsg").innerHTML = "Restarting TeamViewer service, please wait...";
					SYNO.SDS.TeamViewer.Utils.DefaultState();

					Ext.Ajax.request({
						url: SYNO.SDS.TeamViewer.TeamViewerURL + "/TeamViewerWebSupport.cgi",
						scope: this,
						method: "GET",
						params: "method=UnregisterDeviceManager",
						success: function(response) {
							if(typeof response !== "undefined")
							{
								if("success" === response.responseText)
								{
									SYNO.SDS.TeamViewer.DeviceManager = "";
									SYNO.SDS.TeamViewer.Utils.GetDeviceInfo(ApplicationWindow);
								}
								else
								{
									document.getElementById("TV_UnregisterManagerContainer").className = "";
									document.getElementById("TV_UnregisterManager").disabled = false;

									document.getElementById("TV_RemoteTerminal").style.opacity = "1";
									document.getElementById("TV_TerminalButton").disabled = false;

									ApplicationWindow.getMsgBox().alert(_T("error", "error_error"), "Error in unregistering device manager. \nReason: " + response.responseText);
								}
							}
							SYNO.SDS.TeamViewer.UpdateUI = true;
							SYNO.SDS.TeamViewer.Utils.GetDeviceInfo(ApplicationWindow);
							return;
						},
						failure: function(response, connection) {
							document.getElementById("TV_UnregisterManagerContainer").className = "";
							document.getElementById("TV_UnregisterManager").disabled = false;

							document.getElementById("TV_RemoteTerminal").style.opacity = "1";
							document.getElementById("TV_TerminalButton").disabled = false;

							if(typeof response !== "undefined")
							{
								ApplicationWindow.getMsgBox().alert(_T("error", "error_error"), "Error in unregistering device manager. \nReason: " + response.statusText);
							}
							SYNO.SDS.TeamViewer.UpdateUI = true;
							SYNO.SDS.TeamViewer.Utils.GetDeviceInfo(ApplicationWindow);
							return;
						}
					});
				}
			},this);
		}
	},
	TerminalButton: function(ApplicationWindow) {
		if (true === _S("is_admin"))
		{
			var action = "enable";

			if (SYNO.SDS.TeamViewer.IsTerminalEnabled === true)
			{
				action = "disable";
			}

			ApplicationWindow.getMsgBox().confirm('TeamViewer','Do you want to ' + action + ' Remote Terminal?</br> \
													<span style="font-size:0.9em">Note: If you are logged in via TeamViewer then your TeamViewer session will be closed.</span>',function(btn){
				if("yes" === btn)
				{
					clearTimeout(SYNO.SDS.TeamViewer.TimeOutID);
					SYNO.SDS.TeamViewer.UpdateUI = false;

					document.getElementById("TV_UnregisterManagerContainer").className = "x-item-disabled";
					document.getElementById("TV_UnregisterManager").disabled = true;

					document.getElementById("TV_RemoteTerminal").style.opacity = "0.4";
					document.getElementById("TV_TerminalButton").disabled = true;

					document.getElementById("ConnMsg").innerHTML = "Restarting TeamViewer service, please wait...";
					SYNO.SDS.TeamViewer.Utils.DefaultState();

					Ext.Ajax.request({
						url: SYNO.SDS.TeamViewer.TeamViewerURL + "/TeamViewerWebSupport.cgi",
						scope: this,
						method: "GET",
						params: "method=" + action.charAt(0).toUpperCase() + action.slice(1) + "RemoteTerminal",
						success: function(response) {
							if(typeof response !== "undefined")
							{
								{
									ApplicationWindow.getMsgBox().alert(_T("info"), "Remote Terminal " + action + "d");
								}

								if (SYNO.SDS.TeamViewer.IsTerminalEnabled === true)
								{
									SYNO.SDS.TeamViewer.Utils.DisableRemoteTerminal(ApplicationWindow);
								}
								else
								{
									SYNO.SDS.TeamViewer.Utils.EnableRemoteTerminal(ApplicationWindow);
								}

								document.getElementById("TV_RemoteTerminal").style.opacity = "1";
								document.getElementById("TV_TerminalButton").disabled = false;
							}

							SYNO.SDS.TeamViewer.UpdateUI = true;
							SYNO.SDS.TeamViewer.Utils.GetDeviceInfo(ApplicationWindow);
							return;
						},
						failure: function(response, connection) {

							if(typeof response !== "undefined")
							{
								ApplicationWindow.getMsgBox().alert(_T("info", "error_error"), "Error in " + action.slice(0, -1) + "ing Remote Terminal. \nReason: " + response.statusText);
							}

							document.getElementById("TV_RemoteTerminal").style.opacity = "1";
							document.getElementById("TV_TerminalButton").disabled = false;

							SYNO.SDS.TeamViewer.UpdateUI = true;
							SYNO.SDS.TeamViewer.Utils.GetDeviceInfo(ApplicationWindow);

							return;
						}
					});
				}
			},this);
		}
	},
	EnableRemoteTerminal: function(ApplicationWindow) {

		SYNO.SDS.TeamViewer.IsTerminalEnabled = true;
		document.getElementById("TV_TerminalButtonEnabled").style.display = "block";
		document.getElementById("TV_TerminalButtonDisabled").style.display = "none";
	},
	DisableRemoteTerminal: function(ApplicationWindow) {

		SYNO.SDS.TeamViewer.IsTerminalEnabled = false;
		document.getElementById("TV_TerminalButtonEnabled").style.display = "none";
		document.getElementById("TV_TerminalButtonDisabled").style.display = "block";
		document.getElementById("TV_TerminalButtonDisabled").style.borderColor = "#038ff4";
	}
});

Ext.define("SYNO.SDS.TeamViewer.Application", {
	extend: "SYNO.SDS.AppInstance",
	appWindowName: "SYNO.SDS.TeamViewer.MainWindow",
	constructor: function() {
		this.callParent(arguments);
	}
});


// The application window that gets displayed.
Ext.define("SYNO.SDS.TeamViewer.MainWindow", {
	extend: "SYNO.SDS.AppWindow",
	constructor : function(a) {
		this.appInstance = a.appInstance;
		var htmlData = SYNO.SDS.TeamViewer.Utils.GetHtmlData();

		SYNO.SDS.TeamViewer.MainWindow.superclass.constructor.call(this, Ext.apply({
			layout : "fit",
			resizable : false,
			cls: "syno-tv-win",
			maximizable : false,
			minimizable : true,
			width : 450,
			height : 480,
			html: htmlData
		}, a));

		var thisObject = this;

		SYNO.SDS.TeamViewer.SynologySerial = "-";
		this.GetDSInfo();

		document.getElementById("TVDownloadSupport").addEventListener("click", function () {
			SYNO.SDS.TeamViewer.Utils.DownloadSupportFile(thisObject);
		});

		document.getElementById("TVThirdPartyLicense").addEventListener("click", function () {
			SYNO.SDS.TeamViewer.Utils.ThirdPartyLicense(thisObject);
		});

		document.getElementById("TV_UnregisterManager").addEventListener("click", function () {
			SYNO.SDS.TeamViewer.Utils.UnregisterDeviceManager(thisObject);
		});

		document.getElementById("TV_TerminalButton").addEventListener("click", function () {
			SYNO.SDS.TeamViewer.Utils.TerminalButton(thisObject);
		});

		SYNO.SDS.TeamViewer.DeviceManager = "";
		SYNO.SDS.TeamViewer.UpdateUI = true;
		SYNO.SDS.TeamViewer.IsTerminalEnabled = false;

		var hostURL = window.location.href.slice(0, window.location.href.lastIndexOf("/"));
		SYNO.SDS.TeamViewer.TeamViewerURL = hostURL + "/" + this.jsConfig.jsBaseURL;

		SYNO.SDS.TeamViewer.TimeOutID = setTimeout(SYNO.SDS.TeamViewer.Utils.GetDeviceInfo, 500);
	},
	onOpen : function() {
		SYNO.SDS.TeamViewer.MainWindow.superclass.onOpen.apply(this, arguments);

	},
	GetDSInfo: function() {

		var apiVersion = 1;

		if(this.getDsmVersion() >= "6.0")
		{
			apiVersion = 2;
		}

		this.sendWebAPI({
			api: "SYNO.Core.System",
			method: "info",
			version: apiVersion,
			callback: function(status, data, a) {

			   if(status === false)
			   {
				   console.log("GetDSInfo: Failed to get Synology Info");
				   return;
			   }

			   SYNO.SDS.TeamViewer.SynologySerial = data.serial;
			},
			scope: this
		});
	},
	onRequest : function(a) {
		SYNO.SDS.TeamViewer.MainWindow.superclass.onRequest.call(this, a);
	},
	onClose : function() {

		clearTimeout(SYNO.SDS.TeamViewer.TimeOutID);
		SYNO.SDS.TeamViewer.TimeOutID = undefined;
		SYNO.SDS.TeamViewer.MainWindow.superclass.onClose.apply(this, arguments);

		this.doClose();
		return true;
	}
});
